function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'inside_telecommunications', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1049010,v:'normalState'},{id:1049020,v:'normalState'},{id:1049030,v:'normalState'},{id:1049051,v:'normalState'},{id:1049066,v:'normalState'},{id:1049074,v:'normalState'},{id:1049088,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720734,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1283427,v:'normalState'},{id:1167948,v:'normalState'},{id:1167992,v:'normalState'},{id:1275160,v:'normalState'},{id:1275172,v:'normalState'},{id:1275184,v:'normalState'},{id:1284742,v:'normalState'},{id:1289186,v:'normalState'},{id:1275369,v:'normalState'},{id:1275377,v:'normalState'},{id:1275385,v:'normalState'},{id:1275393,v:'normalState'},{id:1290598,v:'normalState'},{id:1275407,v:'normalState'},{id:1275421,v:'normalState'},{id:1293734,v:'normalState'},{id:1293890,v:'normalState'},{id:1294023,v:'normalState'},{id:1275599,v:'normalState'},{id:1275613,v:'normalState'},{id:1275631,v:'normalState'},{id:1300191,v:'normalState'},{id:1275833,v:'normalState'},{id:1275847,v:'normalState'},{id:1275875,v:'normalState'},{id:1301852,v:'normalState'},{id:1275677,v:'normalState'},{id:1275691,v:'normalState'},{id:1275709,v:'normalState'},{id:1302633,v:'normalState'},{id:1276449,v:'normalState'},{id:1276493,v:'normalState'},{id:1276760,v:'normalState'},{id:1307341,v:'normalState'},{id:1303672,v:'normalState'},{id:1303662,v:'normalState'},{id:1276973,v:'normalState'},{id:1276984,v:'normalState'},{id:1311151,v:'normalState'},{id:1276964,v:'normalState'},{id:1277143,v:'normalState'},{id:1277161,v:'normalState'},{id:1277178,v:'normalState'},{id:1277194,v:'normalState'},{id:1277210,v:'normalState'},{id:1277226,v:'normalState'},{id:1277242,v:'normalState'},{id:1277258,v:'normalState'},{id:1277274,v:'normalState'},{id:1277290,v:'normalState'},{id:1277306,v:'normalState'},{id:1277322,v:'normalState'},{id:1277338,v:'normalState'},{id:1316281,v:'normalState'},{id:1277514,v:'normalState'},{id:1318389,v:'normalState'},{id:1277542,v:'normalState'},{id:1277553,v:'normalState'},{id:1233551,v:'normalState'},{id:1233595,v:'normalState'},{id:1278315,v:'normalState'},{id:1278327,v:'normalState'},{id:1278339,v:'normalState'},{id:1278351,v:'normalState'},{id:1278368,v:'normalState'},{id:1278392,v:'normalState'},{id:1323297,v:'normalState'},{id:1323589,v:'normalState'},{id:1278439,v:'normalState'},{id:1278449,v:'normalState'},{id:1278124,v:'normalState'},{id:1278136,v:'normalState'},{id:1278148,v:'normalState'},{id:1278160,v:'normalState'},{id:1278177,v:'normalState'},{id:1278201,v:'normalState'},{id:1325590,v:'normalState'},{id:1325859,v:'normalState'},{id:1278248,v:'normalState'},{id:1278258,v:'normalState'},{id:1278506,v:'normalState'},{id:1278518,v:'normalState'},{id:1278530,v:'normalState'},{id:1278542,v:'normalState'},{id:1278559,v:'normalState'},{id:1278583,v:'normalState'},{id:1327249,v:'normalState'},{id:1327463,v:'normalState'},{id:1278630,v:'normalState'},{id:1278640,v:'normalState'},{id:1278697,v:'normalState'},{id:1278709,v:'normalState'},{id:1278721,v:'normalState'},{id:1278733,v:'normalState'},{id:1278750,v:'normalState'},{id:1278778,v:'normalState'},{id:1329100,v:'normalState'},{id:1329366,v:'normalState'},{id:1278833,v:'normalState'},{id:1278843,v:'normalState'},{id:1278067,v:'normalState'},{id:1279063,v:'normalState'},{id:1279085,v:'normalState'},{id:1279450,v:'normalState'},{id:1279458,v:'normalState'},{id:1279466,v:'normalState'},{id:1279484,v:'normalState'},{id:1279498,v:'normalState'},{id:1279512,v:'normalState'},{id:1279727,v:'normalState'},{id:1339466,v:'normalState'},{id:1339700,v:'normalState'},{id:1339881,v:'normalState'},{id:1279679,v:'normalState'},{id:1279690,v:'normalState'},{id:1279701,v:'normalState'},{id:1279712,v:'normalState'},{id:1279845,v:'normalState'},{id:1279856,v:'normalState'},{id:1343153,v:'normalState'},{id:1279881,v:'normalState'},{id:1345655,v:'normalState'},{id:1280071,v:'normalState'},{id:1280080,v:'normalState'},{id:1280089,v:'normalState'},{id:1280098,v:'normalState'},{id:1349093,v:'normalState'},{id:1354952,v:'normalState'},{id:1358995,v:'normalState'},{id:1359084,v:'normalState'},{id:1359164,v:'normalState'},{id:1349085,v:'normalState'},{id:1280282,v:'normalState'},{id:1280326,v:'normalState'},{id:70221,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:1055430,v:'normalState'},{id:1055444,v:'normalState'},{id:923576,v:'normalState'},{id:923590,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
